/*
 * Ubiquity REST API
 * Ubiquity provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Protocols #### Mainnet The following protocols are currently supported: * bitcoin * ethereum * polkadot * xrp * algorand * stellar * dogecoin * oasis * stacks * near  #### Testnet * bitcoin/testnet * ethereum/ropsten * dogecoin/testnet  #### Native Ubiquity provides native access to all Blockchain nodes it supports. To access native functionality, use the protocol without the v2 prefix * bitcoin/(mainnet | testnet) - [RPC Documentation](https://developer.bitcoin.org/reference/rpc/) * ethereum/(mainnet | ropsten) - [RPC Documentation](https://ethereum.org/en/developers/docs/apis/json-rpc/) * polkadot/mainnet - [Sidecar API Documentation](https://paritytech.github.io/substrate-api-sidecar/dist/) * polkadot/mainnet/http-rpc - [Polkadot RPC Documentation](https://polkadot.js.org/docs/substrate/rpc/) * algorand/mainnet - [Algod API Documentation](https://developer.algorand.org/docs/reference/rest-apis/algod/v1/) * stellar/mainnet - [Stellar Horizon API Documentation](https://developers.stellar.org/api) * dogecoin/(mainnet | testnet) - [Dogecoin API Documentaion](https://developer.bitcoin.org/reference/rpc/) * oasis/mainnet - [Oasis Rosetta Gateway Documentation](https://www.rosetta-api.org/docs/api_identifiers.html#network-identifier) * stacks/mainnet - [Stacks API Documentation](https://blockstack.github.io/stacks-blockchain-api/) * near/mainnet - [NEAR RPC Documentation](https://docs.near.org/docs/api/rpc)  A full URL example: https://ubiquity.api.blockdaemon.com/_**bitcoin/mainnet**  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available. 
 *
 * The version of the OpenAPI document: 2.0.0
 * Contact: support@blockdaemon.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.gitlab.blockdaemon.ubiquity.api;

import com.gitlab.blockdaemon.ubiquity.invoker.ApiCallback;
import com.gitlab.blockdaemon.ubiquity.invoker.ApiClient;
import com.gitlab.blockdaemon.ubiquity.invoker.ApiException;
import com.gitlab.blockdaemon.ubiquity.invoker.ApiResponse;
import com.gitlab.blockdaemon.ubiquity.invoker.Configuration;
import com.gitlab.blockdaemon.ubiquity.invoker.Pair;
import com.gitlab.blockdaemon.ubiquity.invoker.ProgressRequestBody;
import com.gitlab.blockdaemon.ubiquity.invoker.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.gitlab.blockdaemon.ubiquity.model.Error;
import com.gitlab.blockdaemon.ubiquity.model.Report;
import com.gitlab.blockdaemon.ubiquity.model.TxPage;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class AccountsApi {
    private ApiClient localVarApiClient;

    public AccountsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public AccountsApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for getBalancesByAddress
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param address Account address (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Balances </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad request </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBalancesByAddressCall(String platform, String network, String address, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/{platform}/{network}/account/{address}"
            .replaceAll("\\{" + "platform" + "\\}", localVarApiClient.escapeString(platform.toString()))
            .replaceAll("\\{" + "network" + "\\}", localVarApiClient.escapeString(network.toString()))
            .replaceAll("\\{" + "address" + "\\}", localVarApiClient.escapeString(address.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/problem+json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getBalancesByAddressValidateBeforeCall(String platform, String network, String address, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'platform' is set
        if (platform == null) {
            throw new ApiException("Missing the required parameter 'platform' when calling getBalancesByAddress(Async)");
        }
        
        // verify the required parameter 'network' is set
        if (network == null) {
            throw new ApiException("Missing the required parameter 'network' when calling getBalancesByAddress(Async)");
        }
        
        // verify the required parameter 'address' is set
        if (address == null) {
            throw new ApiException("Missing the required parameter 'address' when calling getBalancesByAddress(Async)");
        }
        

        okhttp3.Call localVarCall = getBalancesByAddressCall(platform, network, address, _callback);
        return localVarCall;

    }

    /**
     * Balances Of Address
     * Returns the account balances for all supported currencies. 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param address Account address (required)
     * @return Map&lt;String, Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Balances </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad request </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public Map<String, Object> getBalancesByAddress(String platform, String network, String address) throws ApiException {
        ApiResponse<Map<String, Object>> localVarResp = getBalancesByAddressWithHttpInfo(platform, network, address);
        return localVarResp.getData();
    }

    /**
     * Balances Of Address
     * Returns the account balances for all supported currencies. 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param address Account address (required)
     * @return ApiResponse&lt;Map&lt;String, Object&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Balances </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad request </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Map<String, Object>> getBalancesByAddressWithHttpInfo(String platform, String network, String address) throws ApiException {
        okhttp3.Call localVarCall = getBalancesByAddressValidateBeforeCall(platform, network, address, null);
        Type localVarReturnType = new TypeToken<Map<String, Object>>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Balances Of Address (asynchronously)
     * Returns the account balances for all supported currencies. 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param address Account address (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Balances </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad request </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBalancesByAddressAsync(String platform, String network, String address, final ApiCallback<Map<String, Object>> _callback) throws ApiException {

        okhttp3.Call localVarCall = getBalancesByAddressValidateBeforeCall(platform, network, address, _callback);
        Type localVarReturnType = new TypeToken<Map<String, Object>>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getReportByAddress
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param address Account address (required)
     * @param from Unix Timestamp from where to start (optional)
     * @param to Unix Timestamp from where to end (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Account Activity </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad request </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
        <tr><td> 413 </td><td> Too Many Transactions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getReportByAddressCall(String platform, String network, String address, Integer from, Integer to, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/{platform}/{network}/account/{address}/report"
            .replaceAll("\\{" + "platform" + "\\}", localVarApiClient.escapeString(platform.toString()))
            .replaceAll("\\{" + "network" + "\\}", localVarApiClient.escapeString(network.toString()))
            .replaceAll("\\{" + "address" + "\\}", localVarApiClient.escapeString(address.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (from != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("from", from));
        }

        if (to != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("to", to));
        }

        final String[] localVarAccepts = {
            "application/json", "text/csv", "application/problem+json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getReportByAddressValidateBeforeCall(String platform, String network, String address, Integer from, Integer to, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'platform' is set
        if (platform == null) {
            throw new ApiException("Missing the required parameter 'platform' when calling getReportByAddress(Async)");
        }
        
        // verify the required parameter 'network' is set
        if (network == null) {
            throw new ApiException("Missing the required parameter 'network' when calling getReportByAddress(Async)");
        }
        
        // verify the required parameter 'address' is set
        if (address == null) {
            throw new ApiException("Missing the required parameter 'address' when calling getReportByAddress(Async)");
        }
        

        okhttp3.Call localVarCall = getReportByAddressCall(platform, network, address, from, to, _callback);
        return localVarCall;

    }

    /**
     * A financial report for an address between a time period. Default timescale is within the last 30 days
     * Returns account activity 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param address Account address (required)
     * @param from Unix Timestamp from where to start (optional)
     * @param to Unix Timestamp from where to end (optional)
     * @return Report
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Account Activity </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad request </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
        <tr><td> 413 </td><td> Too Many Transactions </td><td>  -  </td></tr>
     </table>
     */
    public Report getReportByAddress(String platform, String network, String address, Integer from, Integer to) throws ApiException {
        ApiResponse<Report> localVarResp = getReportByAddressWithHttpInfo(platform, network, address, from, to);
        return localVarResp.getData();
    }

    /**
     * A financial report for an address between a time period. Default timescale is within the last 30 days
     * Returns account activity 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param address Account address (required)
     * @param from Unix Timestamp from where to start (optional)
     * @param to Unix Timestamp from where to end (optional)
     * @return ApiResponse&lt;Report&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Account Activity </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad request </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
        <tr><td> 413 </td><td> Too Many Transactions </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Report> getReportByAddressWithHttpInfo(String platform, String network, String address, Integer from, Integer to) throws ApiException {
        okhttp3.Call localVarCall = getReportByAddressValidateBeforeCall(platform, network, address, from, to, null);
        Type localVarReturnType = new TypeToken<Report>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * A financial report for an address between a time period. Default timescale is within the last 30 days (asynchronously)
     * Returns account activity 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param address Account address (required)
     * @param from Unix Timestamp from where to start (optional)
     * @param to Unix Timestamp from where to end (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Account Activity </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad request </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
        <tr><td> 413 </td><td> Too Many Transactions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getReportByAddressAsync(String platform, String network, String address, Integer from, Integer to, final ApiCallback<Report> _callback) throws ApiException {

        okhttp3.Call localVarCall = getReportByAddressValidateBeforeCall(platform, network, address, from, to, _callback);
        Type localVarReturnType = new TypeToken<Report>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getTxsByAddress
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param address Account address (required)
     * @param order Pagination order (optional)
     * @param continuation Continuation token from earlier response (optional)
     * @param limit Max number of items to return in a response. Defaults to 25 and is capped at 100.  (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Transactions </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Invalid address </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Invalid continuation </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getTxsByAddressCall(String platform, String network, String address, String order, String continuation, Integer limit, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/{platform}/{network}/account/{address}/txs"
            .replaceAll("\\{" + "platform" + "\\}", localVarApiClient.escapeString(platform.toString()))
            .replaceAll("\\{" + "network" + "\\}", localVarApiClient.escapeString(network.toString()))
            .replaceAll("\\{" + "address" + "\\}", localVarApiClient.escapeString(address.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (order != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("order", order));
        }

        if (continuation != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("continuation", continuation));
        }

        if (limit != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("limit", limit));
        }

        final String[] localVarAccepts = {
            "application/json", "application/problem+json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getTxsByAddressValidateBeforeCall(String platform, String network, String address, String order, String continuation, Integer limit, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'platform' is set
        if (platform == null) {
            throw new ApiException("Missing the required parameter 'platform' when calling getTxsByAddress(Async)");
        }
        
        // verify the required parameter 'network' is set
        if (network == null) {
            throw new ApiException("Missing the required parameter 'network' when calling getTxsByAddress(Async)");
        }
        
        // verify the required parameter 'address' is set
        if (address == null) {
            throw new ApiException("Missing the required parameter 'address' when calling getTxsByAddress(Async)");
        }
        

        okhttp3.Call localVarCall = getTxsByAddressCall(platform, network, address, order, continuation, limit, _callback);
        return localVarCall;

    }

    /**
     * Transactions Of Address
     * Gets transactions that an address was involved with, from newest to oldest. This call uses pagination. 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param address Account address (required)
     * @param order Pagination order (optional)
     * @param continuation Continuation token from earlier response (optional)
     * @param limit Max number of items to return in a response. Defaults to 25 and is capped at 100.  (optional)
     * @return TxPage
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Transactions </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Invalid address </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Invalid continuation </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public TxPage getTxsByAddress(String platform, String network, String address, String order, String continuation, Integer limit) throws ApiException {
        ApiResponse<TxPage> localVarResp = getTxsByAddressWithHttpInfo(platform, network, address, order, continuation, limit);
        return localVarResp.getData();
    }

    /**
     * Transactions Of Address
     * Gets transactions that an address was involved with, from newest to oldest. This call uses pagination. 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param address Account address (required)
     * @param order Pagination order (optional)
     * @param continuation Continuation token from earlier response (optional)
     * @param limit Max number of items to return in a response. Defaults to 25 and is capped at 100.  (optional)
     * @return ApiResponse&lt;TxPage&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Transactions </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Invalid address </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Invalid continuation </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<TxPage> getTxsByAddressWithHttpInfo(String platform, String network, String address, String order, String continuation, Integer limit) throws ApiException {
        okhttp3.Call localVarCall = getTxsByAddressValidateBeforeCall(platform, network, address, order, continuation, limit, null);
        Type localVarReturnType = new TypeToken<TxPage>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Transactions Of Address (asynchronously)
     * Gets transactions that an address was involved with, from newest to oldest. This call uses pagination. 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param address Account address (required)
     * @param order Pagination order (optional)
     * @param continuation Continuation token from earlier response (optional)
     * @param limit Max number of items to return in a response. Defaults to 25 and is capped at 100.  (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Transactions </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Invalid address </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Invalid continuation </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getTxsByAddressAsync(String platform, String network, String address, String order, String continuation, Integer limit, final ApiCallback<TxPage> _callback) throws ApiException {

        okhttp3.Call localVarCall = getTxsByAddressValidateBeforeCall(platform, network, address, order, continuation, limit, _callback);
        Type localVarReturnType = new TypeToken<TxPage>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
